#include "stdafx.h"
#include "NeMessenger.h"
#include "FavoriteCreateDlg.h"



IMPLEMENT_DYNAMIC(CFavoriteCreateDlg, CBaseDlgStyleOne)

CFavoriteCreateDlg::CFavoriteCreateDlg(CWnd* pParent /*=NULL*/)
	: CBaseDlgStyleOne(CFavoriteCreateDlg::IDD, pParent)
{
	m_nNewGroupID = 0;
}

CFavoriteCreateDlg::~CFavoriteCreateDlg()
{
	//g_pMessengerActor->GetWASActor()->UnRegisterObserver(this);	
	g_pMessengerActor->UnRegisterObserver(this);
}

void CFavoriteCreateDlg::DoDataExchange(CDataExchange* pDX)
{
	CBaseDlgStyleOne::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_EDIT_NAME, m_edName);
	DDX_Control(pDX, IDC_STATIC_INFO, m_stInfo);
	DDX_Control(pDX, IDOK, m_btnOK);
	DDX_Control(pDX, IDCANCEL, m_btnCancel);
}


BEGIN_MESSAGE_MAP(CFavoriteCreateDlg, CBaseDlgStyleOne)
END_MESSAGE_MAP()


// CFavoriteCreateDlg ޽ óԴϴ.

BOOL CFavoriteCreateDlg::OnInitDialog()
{
	CBaseDlgStyleOne::OnInitDialog();

	ModifyStyle(0, WS_CLIPCHILDREN);

	__ResourceLoad(TRUE);

	g_pMessengerActor->RegisterObserver(this);
	//IGTWASActor *pWASActor = g_pMessengerActor->GetWASActor();
	//pWASActor->RegisterObserver(this);

	m_edName.SetFocus();

	return FALSE;  // return TRUE unless you set the focus to a control
}

void CFavoriteCreateDlg::__ResourceLoad(BOOL bInit)
{
	SetWindowText(LoadStringFromResource(IDS_STRING262));	
	if (m_stInfo.GetSafeHwnd())
	{
		m_stInfo.SetFont(&g_ftDefault12PX);
		m_stInfo.SetWindowText(LoadStringFromResource(IDS_STRING570));
	}
	if (m_btnOK.GetSafeHwnd())
	{
		m_btnOK.SetFont(&g_ftDefault12PX);
		m_btnOK.SetWindowText(LoadStringFromResource(IDS_STRING568));
	}
	if (m_btnCancel.GetSafeHwnd())
	{
		m_btnCancel.SetFont(&g_ftDefault12PX);
		m_btnCancel.SetWindowText(LoadStringFromResource(IDS_STRING569));
	}

	if (bInit == FALSE)
		SendMessage(WM_SIZE, NULL, NULL);
}

void CFavoriteCreateDlg::OnOK()
{
	CString strFavoriteName = _T("");
	m_edName.GetWindowText(strFavoriteName);
    strFavoriteName.Trim();

	CString strMessage;
	const IGTBuddyGroup* pBuddyGroup = g_pMessengerActor->GetBuddyGroupInfo(strFavoriteName);
	if( pBuddyGroup != NULL )
	{
		strMessage.LoadString(IDS_STRING253);
		NMessageBox(this, strMessage);
		return;
	}

	if (strFavoriteName.IsEmpty())
	{
		NMessageBox(this, LoadStringFromResource(IDS_STRING265));	//  ׷ Է ּ.
		return;
	}

	if(g_pMessengerActor->GetBuddyGroupCount() >= MAX_GROUP)
	{	
		CString strMaxGroupCnt;
		strMaxGroupCnt.Format(IDS_STRING227, MAX_GROUP);
		//AfxMessageBox(strMaxGroupCnt);
		NMessageBox(this, strMaxGroupCnt);
		return;
	}

	if (g_pMessengerActor->RequestAddBuddyGroup(strFavoriteName, buddyGroupAction_OrgChart) == false)
	{
		NTALK_LOG->Debug(L"[BUDDY] RequestAddBuddyGroup(%s, %d) Failed", strFavoriteName, buddyGroupAction_OrgChart);
		NMessageBox(this, LoadStringFromResource(IDS_STRING266));
	}
	else
		NTALK_LOG->Debug(L"[BUDDY] RequestAddBuddyGroup(%s, %d) Succeeded", strFavoriteName, buddyGroupAction_OrgChart);

	//CBaseDlgStyleOne::OnOK();
}

bool CFavoriteCreateDlg::OnGTMessengerActor_ResponseBuddyGroupAction(IGTMessengerActor *pActor, const GT_BUDDY_GROUP_RESULT_DATA& sData, GTBuddyAddGroupType addGroupType)
{
	switch (sData.eAction)
	{
		case buddyGroupAction_Add:
			if( addGroupType != buddyGroupAction_OrgChart )
				break;

			if (sData.eError == buddyGroupError_None)
			{
				m_nNewGroupID = sData.nGroupID;
				CBaseDlgStyleOne::OnOK();
			}
			else
			{
				// CNeMessengerDlg  ݹ ް ִ.
				// ׷ ߰ н 2 Լ ÿ ȣǰ, 
				// ޽ ڽ ΰ   ֱ  ⿡  ʴ´.
			}
			break;

		default:
			break;
	}

	return true;
}

BOOL CFavoriteCreateDlg::PreTranslateMessage(MSG* pMsg)
{
	if (pMsg->message == WM_KEYDOWN)
	{
		if (pMsg->wParam == VK_RETURN)
		{
			OnOK();
			return TRUE;
		}
	}

	return __super::PreTranslateMessage(pMsg);
}
